#ifndef ALGO_H
#define ALGO_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include "assert.h"


#define LINE_LENGTH 300000
#define EPSCONV 1e-12
typedef unsigned long long RANDOM_TYPE;
#define MYRAND64  (myrand64 = (6364136223846793005ULL * myrand64))
#define MASSIMO_RAND64     0XFFFFFFFFFFFFFFFFULL
RANDOM_TYPE myrand64;
double inv_massimo_rand64;
#define FRANDOM (MYRAND64 * inv_massimo_rand64)


#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))


typedef struct{
	char ****pa;
	int    **np;
	int     *wp;
	int       n;

} extpart;

typedef struct{
	char ***pa;
	int     np[2];

} edgepart;

struct val_index{
	char * val;
	int index;
}; 



struct int_index {
	int  val;
	int index;
};


typedef struct{
        int *pun;
        int *vec;
        int size;
} punlist;



typedef struct {
	int s1;
	int s2;
	double dist;
} edge;

typedef edge * pedge;

typedef struct {
	int id;
	int nn;
	int nneigh;
	int newick;
	char *name;
	char *labelnewick;
	int neigh[3];
	int siteneigh[3];
	int father;
	int sons[2];
	double weights[2];
        double prob;
} node;

typedef node * pnode;

typedef struct {

        int nleaves;
	int nnodes;
	int nedges;
	int ninternaledges;
	int *leaves;
	char **leavesname;
	char **internname;
	double **leavesdist;
	int **topodist;
	
	punlist internaledge; 
	pedge Edge;
        pnode Node;


} Graph;



#endif
