#include "algo.h"
       

extern struct val_index * vpart;

void Branch_Dist(Graph g, int i, int i1, int j, double dist, double *finaldist)
{
	int l,sito;
	double d = 0;
	

	for( l = 0; l<g.Node[i].nn; ++l ){
		if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
			sito = g.Edge[g.Node[i].neigh[l]].s2;
		else
			sito = g.Edge[g.Node[i].neigh[l]].s1;
		if ( sito != i1 ){			
			if ( sito == j ){
				*finaldist = g.Edge[g.Node[i].neigh[l]].dist + dist;
				return;
			}
			else {
				d  = dist+g.Edge[g.Node[i].neigh[l]].dist;
				Branch_Dist(g,sito,i,j,d , finaldist);		
			}
		}
	}

	return;
}


void Branch_Dist_Topological(Graph g, int i, int i1, int j, int dist, int *finaldist)
{
	int l,sito;
	double d = 0;
	

	for( l = 0; l<g.Node[i].nn; ++l ){
		if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
			sito = g.Edge[g.Node[i].neigh[l]].s2;
		else
			sito = g.Edge[g.Node[i].neigh[l]].s1;
		if ( sito != i1 ){			

			if ( sito == j ){
				*finaldist = 1 + dist;
				return;

			}
			else {
				d  = dist + 1;
				Branch_Dist_Topological(g,sito,i,j,d , finaldist);		
			}
		}
	}

	return;
}


double ** Compute_Leaves_Dist ( Graph g )
{

	int i,j;
	double ** d;
	double a;

	d = (double ** ) malloc ( g.nleaves * sizeof( double * ) );


	for( i = 0; i< g.nleaves; ++i ){
		d[i] = (double *) malloc ( g.nleaves * sizeof( double ));
		d[i][i] = 0;
	}


	for( i = 0; i <g.nleaves-1; ++i ){
		for( j = i+1; j<g.nleaves; ++j ){
			a = 0;
			Branch_Dist(g,i,i,j,0.0,&a);
			d[i][j] = a;
			d[j][i] = d[i][j];
			
		}
	}
	return d;


}
void Compute_Leaves_Dist_Topological ( Graph g , int ** d)
{

	int i,j;
	int a;

	for( i = 0; i< g.nleaves; ++i ){
		d[i][i] = 0;
	}

	for( i = 0; i <g.nleaves-1; ++i ){
		for( j = i+1; j<g.nleaves; ++j ){
			a = 0;
	
			Branch_Dist_Topological(g,i,i,j,0.0,&a);
		
			d[i][j] = a;
			d[j][i] = d[i][j];
			
		}
	}

}


double CalcolaLengthPauplin(Graph g, int **d){

	int i,j;
	double length;

	length=0;
	for( i = 0; i< g.nleaves; ++i ){
		for( j = 0; j< g.nleaves; ++j ){
			length+=g.leavesdist[i][j]*1./pow(2.0,d[i][j]);
		}
	}
	return length;

}
//RETURNLINKNEIGHBORS
void ReturnLinkNeighbors( Graph g, int edge, int *s1, int *s2, int *s11, int *s12,  int * s21, int *s22, int *e11, int *e12, int *e21, int *e22) 
{
	int i,counter;	
	int v[2];
	int e[2];

   
	*s1 = g.Edge[edge].s1;
	*s2 = g.Edge[edge].s2;

	counter = 0;

	for( i = 0; i< g.Node[*s1].nn; ++i )
		if ( g.Node[*s1].neigh[i] != edge ){
			e[counter] =  g.Node[*s1].neigh[i];
			if ( g.Edge[g.Node[*s1].neigh[i]].s1 != *s1 )
				v[counter] = g.Edge[g.Node[*s1].neigh[i]].s1;
				
			else 
				v[counter] = g.Edge[g.Node[*s1].neigh[i]].s2;
			counter++;
		}
	assert(counter==2);
	*s11 = v[0];
	*s12 = v[1];
	*e11 = e[0];
	*e12 = e[1];

	counter = 0;
	for( i = 0; i< g.Node[*s2].nn; ++i )
		if ( g.Node[*s2].neigh[i] != edge ){
			e[counter] =  g.Node[*s2].neigh[i];
			if ( g.Edge[g.Node[*s2].neigh[i]].s1 != *s2 )
				v[counter] = g.Edge[g.Node[*s2].neigh[i]].s1;
			else 
				v[counter] = g.Edge[g.Node[*s2].neigh[i]].s2;
			counter++;
		}


	assert(counter==2);
	*s21 = v[0];
	*s22 = v[1];
	*e21 = e[0];
	*e22 = e[1];
	
} 
/******************************************************************/




//BUILD_FAMILY
void build_family(Graph g , int i, int e, int *vecleaves, int * nleaves)
{

	int l,sito,nson;
	if (g.Node[i].nn == 1 ){		
		vecleaves[*nleaves] = i ;
	    (*nleaves)++;
		
		if ( g.Edge[g.Node[i].neigh[0]].s1 == i )
			sito = g.Edge[g.Node[i].neigh[0]].s2;
		else
			sito = g.Edge[g.Node[i].neigh[0]].s1;
		g.Node[i].father=sito;
		return;
	}
	
	else{	
		nson=0;
		for( l = 0; l<g.Node[i].nn; l++ ){
			
			if (g.Node[i].neigh[l] == e){
				if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
					sito = g.Edge[g.Node[i].neigh[l]].s2;
				else
					sito = g.Edge[g.Node[i].neigh[l]].s1;
			
			g.Node[i].father=sito;}			
			
			
			
			if (g.Node[i].neigh[l] != e){
				if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
					sito = g.Edge[g.Node[i].neigh[l]].s2;
				else
					sito = g.Edge[g.Node[i].neigh[l]].s1;
				g.Node[i].sons[nson]=sito;
				nson=nson+1;
		

				build_family( g, sito, g.Node[i].neigh[l],vecleaves,nleaves );
					}
			
				}
			
			
		}
		


	return;
}
/*********************************************/

void PrintGraphDot( Graph g )
{
	int i;
	FILE * fp;

	fp = fopen("plotgraph.dot","w");
	fprintf(fp, "digraph{");
	fprintf(fp,"size=\"15,10\";\n");

	for( i=0; i<g.nnodes; ++i )
		fprintf(fp,"%d [label=\"%i\"];\n",i,i);

	for( i=0; i<g.nedges; ++i )
		fprintf(fp,"%i -> %i  [label=e%d];\n", g.Edge[i].s1, g.Edge[i].s2,i);
	
	fprintf(fp, "};\n");
	fclose(fp);
}

void ComputePauplin(Graph g , int i, int e, double dist, double * finaldist, double * vecfinaldist, int *vecleaves, int * nleaves)
{

	int l,sito;
	double d = 1;





	if (g.Node[i].nn == 1 ){
		*finaldist = dist;
		vecfinaldist[*nleaves] = *finaldist;
		vecleaves[*nleaves] = i ;
		(*nleaves)++;
		return;
	}

	else{	
		for( l = 0; l<g.Node[i].nn; ++l ){
			if (g.Node[i].neigh[l] != e){
				if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
					sito = g.Edge[g.Node[i].neigh[l]].s2;
				else
					sito = g.Edge[g.Node[i].neigh[l]].s1;
				if ( sito != i ){
					if ( g.Node[sito].nn == 1 ){
						*finaldist = 2*dist;
						vecfinaldist[*nleaves] = *finaldist;
						vecleaves[*nleaves] = sito;
						(*nleaves)++;
						
					}
					else{
						d  = dist *2;
						ComputePauplin( g, sito, g.Node[i].neigh[l] , d, finaldist, vecfinaldist, vecleaves, nleaves );
					}
				}
			}
			
		}
		//printf("ok finale2 \n");
		return;
	}
	return;
}

void ComputeLeavesFromSite(Graph g , int i, int e, char ** vecleaves, int * nleaves)
{

	int l,sito;


	if (g.Node[i].nn == 1 ){		
		strcpy( vecleaves[*nleaves], g.Node[i].name ) ;
		(*nleaves)++;
		return;
	}

	else{	
		for( l = 0; l<g.Node[i].nn; ++l ){
			if (g.Node[i].neigh[l] != e){
				if ( g.Edge[g.Node[i].neigh[l]].s1 == i )
					sito = g.Edge[g.Node[i].neigh[l]].s2;
				else
					sito = g.Edge[g.Node[i].neigh[l]].s1;
				if ( sito != i ){
					if ( g.Node[sito].nn == 1 ){
						strcpy(vecleaves[*nleaves],g.Node[sito].name);
						(*nleaves)++;
						
					}
					else{
						
						ComputeLeavesFromSite( g, sito, g.Node[i].neigh[l], vecleaves, nleaves );
					}
				}
			}
			
		}
		//printf("ok finale2 \n");
		return;
	}
	return;
}



int cstring_cmp(const void *a, const void *b)
{
    const char **ia = (const char **)a;
    const char **ib = (const char **)b;
    return strcmp(*ia, *ib);
	/* strcmp functions works exactly as expected from
	comparison function */
}


int comp(void const * a, void const * b) {
        struct val_index const *aa = a;
        struct val_index const *bb = b;
        if (aa->val > bb->val)
                return 1;
        if (aa->val < bb->val)
                return -1;
        return 0;
}


void CopyVal(char **orig, struct val_index * vi, int dim){

	int i;
	for(i=0;i<dim;i++){
		strcpy(vi[i].val,orig[i]);
		vi[i].index=i;
	}

}

void CopyValInverse(char **dest, struct val_index * vi, int dim){

	int i;
	for(i=0;i<dim;i++){
		strcpy(dest[i],vi[i].val);
	}

}




void CopyValInt(int *orig, struct int_index * vi, int dim){

        int i;
        for(i=0;i<dim;i++){
                vi[i].val=orig[i];
                vi[i].index=i;
        }

}

void CopyValInverseInt(int *dest, struct int_index * vi, int dim){

        int i;
        for(i=0;i<dim;i++){
                dest[i]=vi[i].val;
        }

}



void NewickRecursion( Graph g, int site, int node, int first )
{
	int i,countflag,vici;
	int nodehelp[2];
	
	countflag=0; vici=0;
	for(i=0; i < g.Node[node].nneigh; i++){
		if(g.Node[node].siteneigh[i] != site){
			nodehelp[vici]=g.Node[node].siteneigh[i];
			countflag+=g.Node[nodehelp[vici]].newick;
			if(!g.Node[nodehelp[vici]].newick && nodehelp[vici]!=first )
				NewickRecursion( g, node,  nodehelp[vici],first);
			vici++;
		}
	}
	
	if(countflag == 2){
		//		g.Node[node].labelnewick = (char * ) malloc ( (strlen(g.Node[nodehelp[0]].labelnewick)+ strlen(g.Node[nodehelp[1]].labelnewick)+100) * sizeof ( char ) );
		sprintf(g.Node[node].labelnewick,"(%s:0.1,%s:0.1)",g.Node[nodehelp[0]].labelnewick,g.Node[nodehelp[1]].labelnewick);
		//		printf("new rec (%s:0.1,%s:0.1)",g.Node[nodehelp[0]].labelnewick,g.Node[nodehelp[1]].labelnewick);
		g.Node[node].newick = 1;
		//	if(!g.Node[site].newick && site!=first)
		//	NewickRecursion( g, node, site,first);
	}
	
}



void PrintNewickFormat( Graph g , int **disttopo ,FILE *fpgrafo)
{
	
	int i,j,x=-1,y=-1;
        int id1,id2;
	int site1,site2=-1,count;
	//	char newick[1000000];

	//	FILE *fpgrafo;


	
	//	fpgrafo = fopen ( nomegrafo, "w" ) ;
	
	//	if ( fpgrafo == NULL ) {
	//      fprintf(stderr, "grafo output file  %s doesn't exist ... exiting\n", nomegrafo );
	//      exit(-1);
        //}


	Compute_Leaves_Dist_Topological ( g , disttopo );
	
	for( i = 0; i <g.nleaves-1; ++i ){
		for( j = i+1; j<g.nleaves; ++j ){
			if (disttopo[i][j] == 2 ) {
				x = i;
				y = j;
				break;
			}
		}
	}



	for( i = 0; i<g.nnodes; ++i ){
		g.Node[i].nneigh=0;
	}

	for( i = 0; i<g.nedges; ++i ){
		id1 = g.Edge[i].s1;
		id2 = g.Edge[i].s2;
		g.Node[id1].siteneigh[g.Node[id1].nneigh]=id2;
		g.Node[id1].nneigh++;
		g.Node[id2].siteneigh[g.Node[id2].nneigh]=id1;
		g.Node[id2].nneigh++;
	}

	for( i = 0; i<g.nnodes; ++i ){
		assert(g.Node[i].nneigh <= 3);
		//		for(j=0;j<g.Node[i].nneigh;j++)
		//printf("i=%d numv=%d vici=%d\n",i,g.Node[i].nneigh,g.Node[i].siteneigh[j]);
		
	}


	assert(g.Node[x].siteneigh[0]==g.Node[y].siteneigh[0]);
	site1= g.Node[x].siteneigh[0];
	// 	g.Node[site1].labelnewick = (char * ) malloc ( (strlen(g.Node[x].labelnewick)+ strlen(g.Node[y].labelnewick)+100) * sizeof ( char ) );
	sprintf(g.Node[site1].labelnewick,"(%s:0.1,%s:0.1)",g.Node[x].labelnewick,g.Node[y].labelnewick);
	//	printf(" dentro il print (%s:0.1,%s:0.1)",g.Node[x].labelnewick,g.Node[y].labelnewick);

	for(i=0;i<g.Node[site1].nn ;i++)
		if(g.Node[site1].siteneigh[i] != x && g.Node[site1].siteneigh[i] != y)
			site2= g.Node[site1].siteneigh[i];
	count=g.nleaves;
	while(count<g.nnodes-1){
		NewickRecursion( g, site1, site2 ,site1);
		count=g.nleaves;
		for( i = g.nleaves; i <g.nnodes; ++i ){
			count+=g.Node[i].newick;
		}
	}

	//	printf("(%s:0.1,%s:0.1)\n",g.Node[site1].labelnewick,g.Node[site2].labelnewick);
	fprintf(fpgrafo,"(%s:0.1,%s:0.1,%s:0.1);\n",g.Node[x].labelnewick,g.Node[y].labelnewick,g.Node[site2].labelnewick);
	//	printf("sono sono sono (%s:0.1,%s:0.1,%s:0.1)\n",g.Node[x].labelnewick,g.Node[y].labelnewick,g.Node[site2].labelnewick);


		//		printf("%d %s\n", i , g.Node[i].labelnewick); 

		

/* 	PrintGraphDot(g); */
	
/* 	if ( g.Edge[g.Node[x].neigh[0]].s1 == x ) */
/* 		site1=g.Edge[g.Node[x].neigh[0]].s2; */
/* 	else */
/* 		site1=g.Edge[g.Node[x].neigh[0]].s1; */

/* 	if ( g.Edge[g.Node[y].neigh[0]].s1 == y ) */
/* 		site2=g.Edge[g.Node[x].neigh[0]].s2; */
/* 	else */
/* 		site2=g.Edge[g.Node[x].neigh[0]].s1; */
	
/* 	assert(site1==site2); */
/* 	// printf("%i %i\n",x,y); */
/* 	//printf("%i %i\n",site1,site2); */
/* 	sprintf(newick,"(%i:0.1,%i:0.1)",x,y); */

/* 	//NewickTransverse( g, site, g.Edge[g.Node[x].neigh[0] , newick, newick ); */
	
/* 	// printf("%s\n",newick); */
	

}
